#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <pthread.h>
#include <netdb.h>
#include <readline/readline.h>
#include <string.h>


void* recv_thread (void *v){
	
	int sock;
	char buff[1024];
	int c;
	sock = (int)v;
	while ((c = recv(sock, buff, 1024, 0)) >= 0){
		printf("Recv: %s", buff);
	}
}


void* send_thread (void *v){
	
	int sock;
	char *buff;
	sock = (int)v;
	
	while (buff = readline("msg> ")){
		buff[strlen(buff)] = '\n';
		send(sock, buff, strlen(buff) + 1, 0);
	}
}



int main (int argc, char *argv[]){
	
	struct sockaddr_in s_addr;
	struct hostent *host;
	int s, len;
	pthread_t sthr, rthr;

	if (argc < 3){
		printf("Usage: chatcl <hostname> <port>\n");
		exit(1);
	}
	
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		perror("Error while creating socket");
		exit(2);
	}
	
	host = gethostbyname(argv[1]);
	if (!host){
		perror("Error while resolving hostname");
		exit(3);
	}
	else{
		len = host->h_length;
		if (len > 0){
			s_addr.sin_family = AF_INET;
			s_addr.sin_port = htons(atoi(argv[2]));
			s_addr.sin_addr.s_addr = inet_addr(argv[1]);
			if (connect(s, (struct sockaddr*)&s_addr, sizeof(s_addr))){
				perror("Error while connecting...");
				exit(4);
			}
			pthread_create (&sthr, NULL, send_thread, (void*)s);
			pthread_create (&rthr, NULL, recv_thread, (void*)s);
			pthread_join(sthr, NULL);
		}
		else{
			perror("Error while resolving hostname");
			exit(3);
		}
	}
}
