import socket
import threading
import sys


class SendThread (threading.Thread):
    def __init__(self, sock):
        threading.Thread.__init__(self)
        self.sock = sock
    def run (self):
        msg = raw_input("msg> ")
        while (msg != "*" and self.sock):
            self.sock.send(msg + "\n")
            msg = raw_input("msg> ")
        if (self.sock):
            print "Exiting, as required!"
            self.sock.shutdown(socket.SHUT_RDWR)
            sys.exit(0)
        else:
            print "Connection closed by remote host!"
        return 

class RecvThread (threading.Thread):
    def __init__ (self, sock):
        threading.Thread.__init__(self)
        self.sock = sock
        self.setDaemon(True)
        pass
    def run (self):
        while (self.sock):
            msg = self.sock.recv(1024)
            if (msg):
                print "Recv: "+msg,
            else:
                print "Connection closed by remote host!"
                return

            
def main ():

    if (len(sys.argv) < 3):
        print "Usage: %s <host> <port>" % sys.argv[0]
        sys.exit(1)
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0);
        s.connect((socket.gethostbyname(sys.argv[1]), int(sys.argv[2])))
    except:
        print "Errors encountered while connecting to client..."
        sys.exit(1)
    rt = RecvThread(s)
    rt.start()
    st = SendThread(s)
    st.start()
    st.join()

if __name__ == "__main__":
    main ()
    
